// -------------------------------------------------------------
// paraboloid.fx
// 
// Copyright (c) 2004 IMAGIRE Takashi. All rights reserved.
// -------------------------------------------------------------


// -------------------------------------------------------------
// }bv_VF[_vO
// -------------------------------------------------------------
float4 paraboloid( float4 vPosition, float4x4 mWV )
{   
	float4 Out = (float4)0;			 // o̓f[^
	float3 pos;
	float l;
	
	float z_min = 0.1;
	float z_max = 100.0;
	
	// ʒuW
	pos = mul( vPosition, mWV ).xyz;
	l = length( pos );
	
	Out.xy = pos.xy * l * (l-pos.z) / dot( pos.xy, pos.xy );
	Out.z = (l-z_min)*z_max/(z_max-z_min);
	
	if( 0 <= pos.z )
	{
		Out.z = (l-z_min)*z_max/(z_max-z_min);
		Out.w = l;
	}else{
		Out.z = 0;
		Out.w = -0.00001;
	}
	
    return Out;
}


