//-------------------------------------------------------------
// File: main.h
//
// Desc: PRT
// Copyright (c) 2004 IMAGIRE Takashi. All rights reserved.
//-------------------------------------------------------------
#pragma once

#define REDUCTION_MAPS 3

//-------------------------------------------------------------
// `萔
//-------------------------------------------------------------
// ݂̓̓f[^ۑ\
struct UserInput
{
    BOOL bRotateUp;
    BOOL bRotateDown;
    BOOL bRotateLeft;
    BOOL bRotateRight;
    BOOL bZoomIn;
    BOOL bZoomOut;
    BOOL bChangeShader;
	
    BOOL bUp;
    BOOL bDown;
    BOOL bLeft;
    BOOL bRight;
};




//-------------------------------------------------------------
// Name: class CMyD3DApplication
// Desc: AvP[ṼNX
//-------------------------------------------------------------
class CMyD3DApplication : public CD3DApplication
{
	enum{
		L_MAX = 1,							// ő̌vZ
		TEX_MAX = ((L_MAX+1)*(L_MAX+1)+3)/4,// PRT̃eNX`
	};
	
	int						m_Shader;		// VF[_̎

	CD3DMesh				*m_pMesh;
	CD3DMesh				*m_pMeshBg;
	CD3DMesh				*m_pMeshEnv;

	D3DXVECTOR3				m_pos;
	D3DXVECTOR3				m_vel;

	// VF[_
	LPD3DXEFFECT		    m_pEffect;		// GtFNg
	D3DXHANDLE				m_hTechnique;	// eNjbN
	D3DXHANDLE				m_hmWVP;		// ϊs
	D3DXHANDLE				m_htSrcTex;		// eNX`

	// HDR
	LPD3DXEFFECT		    m_pEffectHDR;		// GtFNg
	D3DXHANDLE				m_hTechniqueHDR;	// eNjbN
	D3DXHANDLE				m_hmWVP_HDR;		// ϊs
	D3DXHANDLE				m_htTextureHDR;		// eNX`
	LPDIRECT3DTEXTURE9		m_pEnvMap;		// }bv

	// _O^[Qbg
	LPDIRECT3DSURFACE9		m_pMapZ;		// [xobt@
	LPDIRECT3DTEXTURE9		m_pParaboloidTex[2];	// }bv
	LPDIRECT3DSURFACE9		m_pParaboloidSurf[2];	// 
	LPDIRECT3DTEXTURE9		m_pJacobianTex[1][2];	// ̏d

	LPDIRECT3DTEXTURE9		m_pReductionTex [REDUCTION_MAPS];		// kobt@
	LPDIRECT3DSURFACE9		m_pReductionSurf[REDUCTION_MAPS];		// kobt@

	LPDIRECT3DTEXTURE9		m_pMaxNLTex[1];


	// ʏ̍Wϊs
	D3DXMATRIX				m_mWorld;
	D3DXMATRIX				m_mView;
	D3DXMATRIX				m_mProj;

	BOOL					m_bLoadingApp;	// [hH
    CD3DFont*				m_pFont;		// tHg
    UserInput				m_UserInput;	// ̓f[^

    FLOAT                   m_fWorldRotX;   // w]
    FLOAT                   m_fWorldRotY;   // x]
    FLOAT                   m_fViewZoom;    // _̋

protected:
    virtual HRESULT OneTimeSceneInit();
    virtual HRESULT InitDeviceObjects();
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();
    virtual HRESULT Render();
    virtual HRESULT FrameMove();
    virtual HRESULT FinalCleanup();
    virtual HRESULT ConfirmDevice( D3DCAPS9*, DWORD, D3DFORMAT );

	virtual void RenderParaboloidMap();

	HRESULT RenderText();

    void    UpdateInput( UserInput* pUserInput );
public:
    LRESULT MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
    CMyD3DApplication();
    virtual ~CMyD3DApplication();
};

